﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.Globalization;
using System.Threading;

namespace LabelProblem
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            tChart1.Axes.Bottom.Labels.DateTimeFormat = "s";
            tChart1.Axes.Bottom.GetAxisDrawLabel += new Steema.TeeChart.GetAxisDrawLabelEventHandler(Bottom_GetAxisDrawLabel);

            // Populate the chart
            double oadate = 2;      // Corresponds to 1900-1-1 00:00
            double oneSecondIncr = new TimeSpan(0, 0, 1).TotalDays;
            Random rand = new Random();
            double value = 0.5;
            for (int i = 0; i < 285; i++)
            {
                oadate += oneSecondIncr;
                value += rand.NextDouble()-0.5;
                tChart1[0].Add(oadate, value);
            }
        }

        void Bottom_GetAxisDrawLabel(object sender, Steema.TeeChart.GetAxisDrawLabelEventArgs e)
        {
            if (e.DrawLabel)
            {
                Steema.TeeChart.Axis axis = (Steema.TeeChart.Axis)sender;
                try
                {
                    DateTimeFormatInfo dti = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat;
                    DateTime dt = DateTime.ParseExact(e.Text, axis.Labels.DateTimeFormat, dti);

                    string sepChar = ":";

                    e.Text = ((dt.Day - 1) * 24 + dt.Hour).ToString("00") + sepChar + dt.Minute.ToString("00") + sepChar + dt.Second.ToString("00");
                }
                catch (Exception ex)
                {
                    Debug.Assert(false, "Oh no, something terrible happened!", ex.ToString());
                }
            }
        }
    }
}
